////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2010-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government’s use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////

using AMPS.Client.Exceptions;

namespace AMPS.Client
{

    /// <summary>
    /// A no-op implementation of the SubscriptionManager interface that does nothing.
    /// </summary>
    public class DefaultSubscriptionManager : SubscriptionManager
    {
        /// <summary>
        /// Subscribes to a message handler with a message.
        /// </summary>
        /// <param name="messageHandler">The message handler to subscribe.</param>
        /// <param name="message">The message to subscribe to.</param>
        public void subscribe(MessageHandler messageHandler, Message message)
        {
        }

        /// <summary>
        /// Unsubscribes a subscription by subId.
        /// </summary>
        /// <param name="subId">The subscription ID to unsubscribe.</param>
        public void unsubscribe(CommandId subId)
        {
        }

        /// <summary>
        /// Clears all subscriptions.
        /// </summary>
        public void clear()
        {
        }

        /// <summary>
        /// Resubscribes using the provided client.
        /// </summary>
        /// <param name="client">The client to resubscribe.</param>
        public void resubscribe(Client client)
        {
        }

        public FailedResubscribeHandler getFailedResubscribeHandler()
        {
            return null;
        }

        public void setFailedResubscribeHandler(FailedResubscribeHandler failureHandler)
        {
        }
    }
}
