////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2012-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government’s use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////
using System;

namespace AMPS.Client.Exceptions
{
    /// <summary>
    /// Thrown when the regular expression used in a subscription or query is invalid.
    /// Check the regular expression used in subscription, and check the server logs for more details.
    /// </summary>
    public class BufferOverflowException : CommandException
    {
        private const string DefaultMessage = "A buffer overflow exception has occurred.";

        public BufferOverflowException()
            : base(DefaultMessage)
        {
        }

        public BufferOverflowException(string message)
            : base(message)
        {
        }

        public BufferOverflowException(Exception innerException)
            : base(DefaultMessage, innerException)
        {
        }

        public BufferOverflowException(string message, Exception innerException)
            : base(message, innerException)
        {
        }
    }
}

