////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2012-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government’s use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace AMPS.Client
{
    public static class Integer
    {
        public static string toString(int i)
        {
            return Convert.ToString(i);
        }
    }

    public static class Long
    {
        public static string toString(long i)
        {
            return Convert.ToString(i);
        }
    }

    internal static class ExtensionMethods
    {
        internal static byte[] array(this MemoryStream memoryStream)
        {
            return memoryStream.GetBuffer();
        }
        internal static void put(this MemoryStream memoryStream, byte b)
        {
            memoryStream.WriteByte(b);
        }

        internal static void put(this MemoryStream memoryStream, byte[] bytes)
        {
            memoryStream.Write(bytes, 0, bytes.Length);
        }
        internal static void put(this MemoryStream memoryStream, byte[] bytes, int ofs, int len)
        {
            memoryStream.Write(bytes, ofs, len);
        }

        internal static int position(this MemoryStream memoryStream)
        {
            return (int)memoryStream.Position;
        }

        internal static void position(this MemoryStream memoryStream, int newPos)
        {
            memoryStream.Position = newPos;
        }

        internal static StringBuilder append(this StringBuilder stringBuilder, string toAppend)
        {
            return stringBuilder.Append(toAppend);
        }
        internal static string toString(this string s)
        {
            return s;
        }
        internal static string toString(this StringBuilder stringBuilder)
        {
            return stringBuilder.ToString();
        }
        internal static byte[] getBytes(this string text, string encoding)
        {
            return Encoding.GetEncoding(encoding).GetBytes(text);
        }
        internal static byte[] getBytes(this string text)
        {
            return Encoding.ASCII.GetBytes(text);
        }
    }
}
