////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2010-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government’s use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////

using System;
using System.Text;
using AMPS.Client;


namespace AMPS.Client.Fields
{
    /// <summary>
    /// Field data for a Message consisting of the Acknowledgement
    /// Type. This is used to hold the type of Acknowledgement for the
    /// Acknowledgement Message.
    /// </summary>
    public class AckTypeField : Field
    {
        private static byte[] AT_RECEIVED = null;
        private static byte[] AT_PARSED = null;
        private static byte[] AT_PERSISTED = null;
        private static byte[] AT_PROCESSED = null;
        private static byte[] AT_COMPLETED = null;
        private static byte[] AT_STATS = null;
        private static byte[] AT_RECEIVED_PARSED = null;
        private static byte[] AT_RECEIVED_PERSISTED = null;
        private static byte[] AT_RECEIVED_PROCESSED = null;
        private static byte[] AT_RECEIVED_COMPLETED = null;
        private static byte[] AT_RECEIVED_STATS = null;
        private static byte[] AT_PARSED_PERSISTED = null;
        private static byte[] AT_PARSED_PROCESSED = null;
        private static byte[] AT_PARSED_COMPLETED = null;
        private static byte[] AT_PARSED_STATS = null;
        private static byte[] AT_PERSISTED_PROCESSED = null;
        private static byte[] AT_PERSISTED_COMPLETED = null;
        private static byte[] AT_PERSISTED_STATS = null;
        private static byte[] AT_PROCESSED_COMPLETED = null;
        private static byte[] AT_PROCESSED_STATS = null;
        private static byte[] AT_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED = null;
        private static byte[] AT_RECEIVED_PARSED_PROCESSED = null;
        private static byte[] AT_RECEIVED_PARSED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PARSED_STATS = null;
        private static byte[] AT_RECEIVED_PERSISTED_PROCESSED = null;
        private static byte[] AT_RECEIVED_PERSISTED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PERSISTED_STATS = null;
        private static byte[] AT_RECEIVED_PROCESSED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PROCESSED_STATS = null;
        private static byte[] AT_RECEIVED_COMPLETED_STATS = null;
        private static byte[] AT_PARSED_PERSISTED_PROCESSED = null;
        private static byte[] AT_PARSED_PERSISTED_COMPLETED = null;
        private static byte[] AT_PARSED_PERSISTED_STATS = null;
        private static byte[] AT_PARSED_PROCESSED_COMPLETED = null;
        private static byte[] AT_PARSED_PROCESSED_STATS = null;
        private static byte[] AT_PARSED_COMPLETED_STATS = null;
        private static byte[] AT_PERSISTED_PROCESSED_COMPLETED = null;
        private static byte[] AT_PERSISTED_PROCESSED_STATS = null;
        private static byte[] AT_PERSISTED_COMPLETED_STATS = null;
        private static byte[] AT_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_PROCESSED = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PROCESSED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PARSED_PROCESSED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PERSISTED_PROCESSED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PERSISTED_PROCESSED_STATS = null;
        private static byte[] AT_RECEIVED_PERSISTED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_PARSED_PERSISTED_PROCESSED_COMPLETED = null;
        private static byte[] AT_PARSED_PERSISTED_PROCESSED_STATS = null;
        private static byte[] AT_PARSED_PERSISTED_COMPLETED_STATS = null;
        private static byte[] AT_PARSED_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_PERSISTED_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_PROCESSED_COMPLETED = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_PROCESSED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PERSISTED_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_PARSED_PERSISTED_PROCESSED_COMPLETED_STATS = null;
        private static byte[] AT_RECEIVED_PARSED_PERSISTED_PROCESSED_COMPLETED_STATS = null;

        static AckTypeField()
        {

            AT_RECEIVED = Encoding.ASCII.GetBytes("received");
            AT_PARSED = Encoding.ASCII.GetBytes("parsed");
            AT_PERSISTED = Encoding.ASCII.GetBytes("persisted");
            AT_PROCESSED = Encoding.ASCII.GetBytes("processed");
            AT_COMPLETED = Encoding.ASCII.GetBytes("completed");
            AT_STATS = Encoding.ASCII.GetBytes("stats");
            AT_RECEIVED_PARSED = Encoding.ASCII.GetBytes("received,parsed");
            AT_RECEIVED_PERSISTED = Encoding.ASCII.GetBytes("received,persisted");
            AT_RECEIVED_PROCESSED = Encoding.ASCII.GetBytes("received,processed");
            AT_RECEIVED_COMPLETED = Encoding.ASCII.GetBytes("received,completed");
            AT_RECEIVED_STATS = Encoding.ASCII.GetBytes("received,stats");
            AT_PARSED_PERSISTED = Encoding.ASCII.GetBytes("parsed,persisted");
            AT_PARSED_PROCESSED = Encoding.ASCII.GetBytes("parsed,processed");
            AT_PARSED_COMPLETED = Encoding.ASCII.GetBytes("parsed,completed");
            AT_PARSED_STATS = Encoding.ASCII.GetBytes("parsed,stats");
            AT_PERSISTED_PROCESSED = Encoding.ASCII.GetBytes("persisted,processed");
            AT_PERSISTED_COMPLETED = Encoding.ASCII.GetBytes("persisted,completed");
            AT_PERSISTED_STATS = Encoding.ASCII.GetBytes("persisted,stats");
            AT_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("processed,completed");
            AT_PROCESSED_STATS = Encoding.ASCII.GetBytes("processed,stats");
            AT_COMPLETED_STATS = Encoding.ASCII.GetBytes("completed,stats");
            AT_RECEIVED_PARSED_PERSISTED = Encoding.ASCII.GetBytes("received,parsed,persisted");
            AT_RECEIVED_PARSED_PROCESSED = Encoding.ASCII.GetBytes("received,parsed,processed");
            AT_RECEIVED_PARSED_COMPLETED = Encoding.ASCII.GetBytes("received,parsed,completed");
            AT_RECEIVED_PARSED_STATS = Encoding.ASCII.GetBytes("received,parsed,stats");
            AT_RECEIVED_PERSISTED_PROCESSED = Encoding.ASCII.GetBytes("received,persisted,processed");
            AT_RECEIVED_PERSISTED_COMPLETED = Encoding.ASCII.GetBytes("received,persisted,completed");
            AT_RECEIVED_PERSISTED_STATS = Encoding.ASCII.GetBytes("received,persisted,stats");
            AT_RECEIVED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("received,processed,completed");
            AT_RECEIVED_PROCESSED_STATS = Encoding.ASCII.GetBytes("received,processed,stats");
            AT_RECEIVED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,completed,stats");
            AT_PARSED_PERSISTED_PROCESSED = Encoding.ASCII.GetBytes("parsed,persisted,processed");
            AT_PARSED_PERSISTED_COMPLETED = Encoding.ASCII.GetBytes("parsed,persisted,completed");
            AT_PARSED_PERSISTED_STATS = Encoding.ASCII.GetBytes("parsed,persisted,stats");
            AT_PARSED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("parsed,processed,completed");
            AT_PARSED_PROCESSED_STATS = Encoding.ASCII.GetBytes("parsed,processed,stats");
            AT_PARSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("parsed,completed,stats");
            AT_PERSISTED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("persisted,processed,completed");
            AT_PERSISTED_PROCESSED_STATS = Encoding.ASCII.GetBytes("persisted,processed,stats");
            AT_PERSISTED_COMPLETED_STATS = Encoding.ASCII.GetBytes("persisted,completed,stats");
            AT_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("processed,completed,stats");
            AT_RECEIVED_PARSED_PERSISTED_PROCESSED = Encoding.ASCII.GetBytes("received,parsed,persisted,processed");
            AT_RECEIVED_PARSED_PERSISTED_COMPLETED = Encoding.ASCII.GetBytes("received,parsed,persisted,completed");
            AT_RECEIVED_PARSED_PERSISTED_STATS = Encoding.ASCII.GetBytes("received,parsed,persisted,stats");
            AT_RECEIVED_PARSED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("received,parsed,processed,completed");
            AT_RECEIVED_PARSED_PROCESSED_STATS = Encoding.ASCII.GetBytes("received,parsed,processed,stats");
            AT_RECEIVED_PARSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,parsed,completed,stats");
            AT_RECEIVED_PERSISTED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("received,persisted,processed,completed");
            AT_RECEIVED_PERSISTED_PROCESSED_STATS = Encoding.ASCII.GetBytes("received,persisted,processed,stats");
            AT_RECEIVED_PERSISTED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,persisted,completed,stats");
            AT_RECEIVED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,processed,completed,stats");
            AT_PARSED_PERSISTED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("parsed,persisted,processed,completed");
            AT_PARSED_PERSISTED_PROCESSED_STATS = Encoding.ASCII.GetBytes("parsed,persisted,processed,stats");
            AT_PARSED_PERSISTED_COMPLETED_STATS = Encoding.ASCII.GetBytes("parsed,persisted,completed,stats");
            AT_PARSED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("parsed,processed,completed,stats");
            AT_PERSISTED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("persisted,processed,completed,stats");
            AT_RECEIVED_PARSED_PERSISTED_PROCESSED_COMPLETED = Encoding.ASCII.GetBytes("received,parsed,persisted,processed,completed");
            AT_RECEIVED_PARSED_PERSISTED_PROCESSED_STATS = Encoding.ASCII.GetBytes("received,parsed,persisted,processed,stats");
            AT_RECEIVED_PARSED_PERSISTED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,parsed,persisted,completed,stats");
            AT_RECEIVED_PARSED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,parsed,processed,completed,stats");
            AT_RECEIVED_PERSISTED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,persisted,processed,completed,stats");
            AT_PARSED_PERSISTED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("parsed,persisted,processed,completed,stats");
            AT_RECEIVED_PARSED_PERSISTED_PROCESSED_COMPLETED_STATS = Encoding.ASCII.GetBytes("received,parsed,persisted,processed,completed,stats");
        }

        /// <summary>
        /// This method gets the value of the field as an AckTypes.
        /// </summary>
        /// <returns>Message.AckTypes.None if the buffer is null. Otherwise
        /// it returns the matching Message.AckTypes enum.</returns>
        public Message.AckTypes getValue()
        {
            if (this.buffer != null)
            {
                return decodeAckType(this.buffer, this.position, this.length);
            }
            return Message.AckTypes.None;
        }

        /// <summary>
        /// This method sets the value of the field based on the given enum.
        /// </summary>
        /// <param name="v">The value to set.</param>
        public void setValue(Message.AckTypes v)
        {
            if (v == 0)
            {
                reset();
                return;
            }
            switch (v)
            {
                case Message.AckTypes.Received:
                    set(AT_RECEIVED);
                    break;
                case Message.AckTypes.Parsed:
                    set(AT_PARSED);
                    break;
                case Message.AckTypes.Persisted:
                    set(AT_PERSISTED);
                    break;
                case Message.AckTypes.Processed:
                    set(AT_PROCESSED);
                    break;
                case Message.AckTypes.Completed:
                    set(AT_COMPLETED);
                    break;
                case Message.AckTypes.Stats:
                    set(AT_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed:
                    set(AT_RECEIVED_PARSED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted:
                    set(AT_RECEIVED_PERSISTED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Processed:
                    set(AT_RECEIVED_PROCESSED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Completed:
                    set(AT_RECEIVED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Stats:
                    set(AT_RECEIVED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted:
                    set(AT_PARSED_PERSISTED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Processed:
                    set(AT_PARSED_PROCESSED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Completed:
                    set(AT_PARSED_COMPLETED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Stats:
                    set(AT_PARSED_STATS);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Processed:
                    set(AT_PERSISTED_PROCESSED);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Completed:
                    set(AT_PERSISTED_COMPLETED);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Stats:
                    set(AT_PERSISTED_STATS);
                    break;
                case Message.AckTypes.Processed | Message.AckTypes.Completed:
                    set(AT_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Processed | Message.AckTypes.Stats:
                    set(AT_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted:
                    set(AT_RECEIVED_PARSED_PERSISTED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Processed:
                    set(AT_RECEIVED_PARSED_PROCESSED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PARSED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed:
                    set(AT_RECEIVED_PERSISTED_PROCESSED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PERSISTED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PERSISTED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Processed
                     | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Processed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed:
                    set(AT_PARSED_PERSISTED_PROCESSED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Completed:
                    set(AT_PARSED_PERSISTED_COMPLETED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Stats:
                    set(AT_PARSED_PERSISTED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Processed
                     | Message.AckTypes.Completed:
                    set(AT_PARSED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Processed
                     | Message.AckTypes.Stats:
                    set(AT_PARSED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_PARSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Processed
                     | Message.AckTypes.Completed:
                    set(AT_PERSISTED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Processed
                     | Message.AckTypes.Stats:
                    set(AT_PERSISTED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_PERSISTED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Processed | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Processed:
                    set(AT_RECEIVED_PARSED_PERSISTED_PROCESSED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PARSED_PERSISTED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_PERSISTED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Processed | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PARSED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Processed | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PERSISTED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PERSISTED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PERSISTED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Processed
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed | Message.AckTypes.Completed:
                    set(AT_PARSED_PERSISTED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed | Message.AckTypes.Stats:
                    set(AT_PARSED_PERSISTED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_PARSED_PERSISTED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Processed
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_PARSED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Persisted | Message.AckTypes.Processed
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_PERSISTED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Processed
                     | Message.AckTypes.Completed:
                    set(AT_RECEIVED_PARSED_PERSISTED_PROCESSED_COMPLETED);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Processed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_PERSISTED_PROCESSED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_PERSISTED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Processed | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PERSISTED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Parsed | Message.AckTypes.Persisted
                     | Message.AckTypes.Processed | Message.AckTypes.Completed
                     | Message.AckTypes.Stats:
                    set(AT_PARSED_PERSISTED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.Received | Message.AckTypes.Parsed
                     | Message.AckTypes.Persisted | Message.AckTypes.Processed
                     | Message.AckTypes.Completed | Message.AckTypes.Stats:
                    set(AT_RECEIVED_PARSED_PERSISTED_PROCESSED_COMPLETED_STATS);
                    break;
                case Message.AckTypes.None:
                default:
                    reset();
                    break;
            }
        }

        /// <summary>
        /// Decodes the string acknowledgement given by AMPS to Message.AckTypes.
        /// </summary>
        /// <param name="buffer">An array of bytes, which is the first parameter passed to decodeAckType.</param>
        /// <param name="pos">An integer which holds the position of the offset.</param>
        /// <param name="len">An integer which holds the length of the acknowledgement.</param>
        /// <returns>The constant from Message.AckType for the input value.</returns>
        static public Message.AckTypes decodeAckType(byte[] buffer, int pos, int len)
        {
            switch (len)
            {
                case 4: return Message.AckTypes.None;
                case 5: return Message.AckTypes.Stats;
                case 6: return Message.AckTypes.Parsed;
                case 8: return Message.AckTypes.Received;
                case 9:
                    switch (buffer[pos + 1])
                    {
                        case (byte)'e': return Message.AckTypes.Persisted;
                        case (byte)'r': return Message.AckTypes.Processed;
                        case (byte)'o': return Message.AckTypes.Completed;
                    }
                    break;
            }
            return Message.AckTypes.None;
        }

        /// <summary>
        /// Converts the acknowledgement from an enum to a string.
        /// </summary>
        /// <param name="ack">The integer representing the acknowledgement produced by AMPS.</param>
        /// <returns>A string that represents the acknowledgement type.</returns>
        static public String encodeAckType(Message.AckTypes ack)
        {
            switch (ack)
            {
                case Message.AckTypes.Received: return "received";
                case Message.AckTypes.Parsed: return "parsed";
                case Message.AckTypes.Persisted: return "persisted";
                case Message.AckTypes.Processed: return "processed";
                case Message.AckTypes.Completed: return "completed";
                case Message.AckTypes.Stats: return "stats";
                case Message.AckTypes.None: return "none";
                default: return "none";
            }
        }

    }
}

