////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2012-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government’s use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace AMPS.Client.Fields
{
    // <summary>
    // Extension methods for string manipulation.
    // </summary>
    static class ExtensionMethods
    {
        // <summary>
        // Gets the byte array representation of the string using the specified encoding.
        // </summary>
        // <param name="text">The string to convert to byte array.</param>
        // <param name="encoding">The encoding to be used. Currently only supports "ISO-8859-1".</param>
        // <returns>The byte array representation of the string.</returns>
        internal static byte[] getBytes(this string text, string encoding)
        {
            Debug.Assert(encoding == "ISO-8859-1");
            return Encoding.ASCII.GetBytes(text);
        }
    }
}
