////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2010-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government's use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AMPS.Client
{

    /// <summary>
    /// Implements the Protocol interface. Used to parse a byte stream as a series of messages.
    /// The byte stream must used AMPS FIX protocol.
    /// </summary>
    public class JSONProtocol : Protocol
    {

        /// <summary>
        /// Initializes a new instance of the JSONProtocol class.
        /// </summary>
        public JSONProtocol()
        {
        }

        /// <summary>
        /// Initializes a new instance of the JSONProtocol class with
        /// the specified properties.
        /// </summary>
        /// <param name="props">The properties.</param>
        public JSONProtocol(Properties props)
        {
        }

        /// <summary>
        /// Allocates a new JSON Message.
        /// </summary>
        /// <returns>The newly allocated JSON Message.</returns>
        public Message allocateMessage()
        {
            return new JSONMessage(Encoding.UTF8, Encoding.UTF8);
        }

        /// <summary>
        /// Gets the message stream for JSON protocol.
        /// </summary>
        /// <returns>The message stream for JSON protocol.</returns>
        public ProtocolParser getMessageStream()
        {
            return new JSONProtocolParser(this);
        }
    }
}
