using System;
namespace AMPS.Client
{

    /// <summary>
    /// Represents a partial class <see cref="Message"/> containing properties for various message
    /// attributes.
    /// </summary>
    public partial class Message
    {

        /// <summary>
        /// Gets or sets the group sequence number.
        /// </summary>
        public Int64 GroupSeqNo
        {
            get
            {
                return getGroupSeqNo();
            }
            set
            {
                setGroupSeqNo(value);
            }
        }

        /// <summary>
        /// Gets or sets the number of matches.
        /// </summary>
        public Int64 Matches
        {
            get
            {
                return getMatches();
            }
            set
            {
                setMatches(value);
            }
        }

        /// <summary>
        /// Gets or sets the length of the message.
        /// </summary>
        public Int32 Length
        {
            get
            {
                return getLength();
            }
            set
            {
                setLength(value);
            }
        }

        /// <summary>
        /// Gets or sets the query ID.
        /// </summary>
        public String QueryId
        {
            get
            {
                return getQueryId();
            }
            set
            {
                setQueryId(value);
            }
        }

        /// <summary>
        /// Gets or sets the reason.
        /// </summary>
        public Reasons Reason
        {
            get
            {
                return getReason();
            }
            set
            {
                setReason(value);
            }
        }

        /// <summary>
        /// Gets or sets the number of records inserted.
        /// </summary>
        public Int64 RecordsInserted
        {
            get
            {
                return getRecordsInserted();
            }
            set
            {
                setRecordsInserted(value);
            }
        }

        /// <summary>
        /// Gets or sets the number of records updated.
        /// </summary>
        public Int64 RecordsUpdated
        {
            get
            {
                return getRecordsUpdated();
            }
            set
            {
                setRecordsUpdated(value);
            }
        }

        /// <summary>
        /// Gets or sets the number of records deleted.
        /// </summary>
        public Int64 RecordsDeleted
        {
            get
            {
                return getRecordsDeleted();
            }
            set
            {
                setRecordsDeleted(value);
            }
        }

        /// <summary>
        /// Gets or sets the number of records returned.
        /// </summary>
        public Int64 RecordsReturned
        {
            get
            {
                return getRecordsReturned();
            }
            set
            {
                setRecordsReturned(value);
            }
        }

        /// <summary>
        /// Gets or sets the sequence.
        /// </summary>
        public UInt64 Sequence
        {
            get
            {
                return getSequence();
            }
            set
            {
                setSequence(value);
            }
        }

        /// <summary>
        /// Gets or sets the SOW key.
        /// </summary>
        public String SowKey
        {
            get
            {
                return getSowKey();
            }
            set
            {
                setSowKey(value);
            }
        }

        /// <summary>
        /// Gets or sets the SOW keys.
        /// </summary>
        public String SowKeys
        {
            get
            {
                return getSowKeys();
            }
            set
            {
                setSowKeys(value);
            }
        }

        /// <summary>
        /// Gets or sets the status.
        /// </summary>
        public State Status
        {
            get
            {
                return getStatus();
            }
            set
            {
                setStatus(value);
            }
        }

        /// <summary>
        /// Gets or sets the subscription ID.
        /// </summary>
        public String SubId
        {
            get
            {
                return getSubId();
            }
            set
            {
                setSubId(value);
            }
        }

        /// <summary>
        /// Gets or sets the subscription IDs.
        /// </summary>
        public String SubIds
        {
            get
            {
                return getSubIds();
            }
            set
            {
                setSubIds(value);
            }
        }

        /// <summary>
        /// Gets or sets the timestamp.
        /// </summary>
        public String Timestamp
        {
            get
            {
                return getTimestamp();
            }
            set
            {
                setTimestamp(value);
            }
        }

        /// <summary>
        /// Gets or sets the top N value.
        /// </summary>
        public Int64 TopN
        {
            get
            {
                return getTopN();
            }
            set
            {
                setTopN(value);
            }
        }

        /// <summary>
        /// Gets or sets the topic.
        /// </summary>
        public String Topic
        {
            get
            {
                return getTopic();
            }
            set
            {
                setTopic(value);
            }
        }

        /// <summary>
        /// Gets or sets the number of matches for a topic.
        /// </summary>
        public Int64 TopicMatches
        {
            get
            {
                return getTopicMatches();
            }
            set
            {
                setTopicMatches(value);
            }
        }

        /// <summary>
        /// Gets or sets the user ID.
        /// </summary>
        public String UserId
        {
            get
            {
                return getUserId();
            }
            set
            {
                setUserId(value);
            }
        }

        /// <summary>
        /// Gets or sets the password.
        /// </summary>
        public String Password
        {
            get
            {
                return getPassword();
            }
            set
            {
                setPassword(value);
            }
        }

        /// <summary>
        /// Gets or sets the data.
        /// </summary>
        public String Data
        {
            get
            {
                return getData();
            }
            set
            {
                setData(value);
            }
        }

        /// <summary>
        /// Gets or sets the acknowledgement type.
        /// </summary>
        public AckTypes AckType
        {
            get
            {
                return getAckType();
            }
            set
            {
                setAckType(value);
            }
        }

        /// <summary>
        /// Gets or sets the batch size.
        /// </summary>
        public Int32 BatchSize
        {
            get
            {
                return getBatchSize();
            }
            set
            {
                setBatchSize(value);
            }
        }

        /// <summary>
        /// Gets or sets the bookmark.
        /// </summary>
        public String Bookmark
        {
            get
            {
                return getBookmark();
            }
            set
            {
                setBookmark(value);
            }
        }

        /// <summary>
        /// Gets or sets the client name.
        /// </summary>
        public String ClientName
        {
            get
            {
                return getClientName();
            }
            set
            {
                setClientName(value);
            }
        }

        /// <summary>
        /// Gets or sets the command ID.
        /// </summary>
        public String CommandId
        {
            get
            {
                return getCommandId();
            }
            set
            {
                setCommandId(value);
            }
        }

        /// <summary>
        /// Gets or sets the command.
        /// </summary>
        public Commands Command
        {
            get
            {
                return getCommand();
            }
            set
            {
                setCommand(value);
            }
        }

        /// <summary>
        /// Gets or sets the expiration time.
        /// </summary>
        public Int32 Expiration
        {
            get
            {
                return getExpiration();
            }
            set
            {
                setExpiration(value);
            }
        }

        /// <summary>
        /// Gets or sets the filter.
        /// </summary>
        public String Filter
        {
            get
            {
                return getFilter();
            }
            set
            {
                setFilter(value);
            }
        }

        /// <summary>
        /// Gets or sets the order by clause.
        /// </summary>
        public String OrderBy
        {
            get
            {
                return getOrderBy();
            }
            set
            {
                setOrderBy(value);
            }
        }

        /// <summary>
        /// Gets or sets the correlation ID.
        /// </summary>
        public String CorrelationId
        {
            get
            {
                return getCorrelationId();
            }
            set
            {
                setCorrelationId(value);
            }
        }
    }
}


