////////////////////////////////////////////////////////////////////////////
//
// Copyright (c) 2010-2025 60East Technologies Inc., All Rights Reserved.
//
// This computer software is owned by 60East Technologies Inc. and is
// protected by U.S. copyright laws and other laws and by international
// treaties.  This computer software is furnished by 60East Technologies
// Inc. pursuant to a written license agreement and may be used, copied,
// transmitted, and stored only in accordance with the terms of such
// license agreement and with the inclusion of the above copyright notice.
// This computer software or any other copies thereof may not be provided
// or otherwise made available to any other person.
//
// U.S. Government Restricted Rights.  This computer software: (a) was
// developed at private expense and is in all respects the proprietary
// information of 60East Technologies Inc.; (b) was not developed with
// government funds; (c) is a trade secret of 60East Technologies Inc.
// for all purposes of the Freedom of Information Act; and (d) is a
// commercial item and thus, pursuant to Section 12.212 of the Federal
// Acquisition Regulations (FAR) and DFAR Supplement Section 227.7202,
// Government’s use, duplication or disclosure of the computer software
// is subject to the restrictions set forth by 60East Technologies Inc..
//
////////////////////////////////////////////////////////////////////////////
using System.IO;

namespace AMPS.Client
{

    /// <summary>
    /// Represents an interface for parsing protocols.
    /// </summary>
    public interface ProtocolParser
    {
        /// <summary>
        /// Processes the input buffer using the specified length and notifies the listener with parsed messages.
        /// </summary>
        /// <param name="buffer">The input buffer to process.</param>
        /// <param name="length">The length of valid data in the buffer.</param>
        /// <param name="listener">The message handler to notify with parsed messages.</param>
        void process(SimpleReadBuffer buffer, int length, MessageHandler listener);
    }
}
